#!/usr/bin/perl

# license = gpl
# author = jacob jarick, mem.namefix@gmail.com , mem on #wiidev @ efnet

#--------------------------------------------------------------------------------------------------------------
# includes
#--------------------------------------------------------------------------------------------------------------

use CGI qw /:standard -nosticky/;
use Cwd;
use Warnings;
use File::Copy;
use FindBin;


#--------------------------------------------------------------------------------------------------------------
# variables
#--------------------------------------------------------------------------------------------------------------

my $dir = "C:/Program Files/xampp/htdocs/wmc";
#my $dir = $FindBin::Bin;

do "$dir/config.pl" or die "ERROR: couldnt load $dir/config.pl";

#require "config.pl";

$version = "0.2.7.1a";
$wd	= cwd();
$i_wd	= $wd; 		# inital wd, needed for memcoder etc

$mf_ext = "avi|mpeg|mpg|mov|flv|dat|asf|wmv|mp4";

$file 	= param('file');
$action = param('action');
$our_wd	= param('our_wd');

$ico_pic 	= "$theme_dir/ico_img.png";
$ico_mp3 	= "$theme_dir/ico_mp3.png";
$ico_vid 	= "$theme_dir/ico_vid.png";
$ico_zip 	= "$theme_dir/ico_zip.png";
$ico_dir 	= "$theme_dir/ico_dir.png";
$ico_txt 	= "$theme_dir/ico_txt.png";
$ico_home	= "$theme_dir/ico_home.png";
$ico_up		= "$theme_dir/ico_up.png";
$ico_bin		= "$theme_dir/ico_bin.png";
$ico_play	= "$theme_dir/ico_play.png";
$ico_del		= "$theme_dir/ico_del.png";
$ico_config	= "$theme_dir/ico_config.png";
$ico_links	= "$theme_dir/ico_links.png";
$background	= "$theme_dir/background.jpg";

our @drives_data = ();
our @table_data = ();
our @info = ();
our @html = &readf("$theme_local_dir/main.html");

$date = gmtime(time());


#--------------------------------------------------------------------------------------------------------------
# code
#--------------------------------------------------------------------------------------------------------------

print "Content-type: text/html\n\n";

if($our_wd)
{
	chdir $our_wd;
	$wd = $our_wd;
}
else
{
	$our_wd = cwd;
}

#--------------------------------------------------------------------------------------------------------------
# get drives data ready.

@drives_data = &readf("$tpl_local_dir/drives_header.tpl");
@tmp = &readf("$tpl_local_dir/drives_body.tpl");

for $d(@drives)
{
	@tmp2 = @tmp;
	for $line(@tmp2)
	{
		$line =~ s/<<drive>>/$d/ig;
		push @drives_data, $line;
	}
}
push @drives_data, &readf("$tpl_local_dir/drives_footer.tpl");


$vars_data = "<!-- VARS \n\$file = $file\n\$action = $action\n\$our_wd = $our_wd\n-->\n";

#--------------------------------------------------------------------------------------------------------------
# respond to cgi requests

if(!$action)
{
	@info = &lsdir;
}

elsif($action eq "favs")
{
	@info = &readf("$tpl_local_dir/favs_header.tpl");
	@favs = &readf("$favourites");
	@tmp = &readf("$tpl_local_dir/favs_body.tpl");
	for(@favs)
	{
		chomp;
		@tmp2 = @tmp;
		($name, $file) = split(/\t+/);
		for(@tmp2)
		{
			s/<<file>>/$file/ig;
			s/<<name>>/$name/ig;
			s/<<ico_dir>>/$ico_dir/ig;
		}
		push @info, @tmp2;
	}
	push @info, &readf("$tpl_local_dir/favs_footer.tpl");
}

elsif($action eq "vidplay")
{
	$count = param('count');
	$count++;
	$file = "$count"."default.flv";
	$tmpdur = $duration + $refresh_delay;
	
	if(! -f "$flv_local_dir/$file")
	{
		@info = &readf("$tpl_local_dir/error.tpl");
		for(@info)
		{
			$tmp = "video file: $file doesnt exist<BR/>Assuming Video Ended.";
			s/<<error_message>>/$tmp/ig;
		}
	}
	else
	{
		@info = &readf("$tpl_local_dir/vidplay.tpl");
		for(@info)
		{
			s/<<cgi>>/$cgi_dir/ig;
			s/<<file>>/$file/ig;
			s/<<count>>/$count/ig;
			s/<<duration>>/$tmpdur/ig;
			s/<<theme_dir>>/$theme_dir/ig;
		}
		print @info;
		exit 1;
	}
}

elsif($action eq "vidiframe")
{
	$count = param('count');
	$count++;
	$file = "$count"."default.flv";
	$tmpdur = $duration + $refresh_delay;

	@info = &readf("$tpl_local_dir/vidiframe.tpl");

	if(! -f "$flv_local_dir/$file")
	{
		@info = &readf("$tpl_local_dir/error.tpl");
		for(@info)
		{
			$tmp = "video file: $file doesnt exist<BR/>Assuming Video Ended.";
			s/<<error_message>>/$tmp/ig;
		}
	}
	else
	{
		@info = &readf("$tpl_local_dir/vidiframe.tpl");
		for(@info)
		{
			s/<<cgi>>/$cgi_dir/ig;
			s/<<file>>/$file/ig;
			s/<<count>>/$count/ig;
			s/<<duration>>/$tmpdur/ig;
			s/<<theme_dir>>/$theme_dir/ig;
		}
		print @info;
		exit 1;
	}
}

elsif($action eq "config" || $action eq "playlist")
{
	chdir $mp3_local_dir;
	$wd = cwd();
	@info = ();
	push @info, &readf("$tpl_local_dir/playlist_header.tpl");
	@tmp = &lsmp3dir;
	push @info, @tmp;
	push @info, &readf("$tpl_local_dir/playlist_footer.tpl");
}

elsif($action eq "delete")
{
	@info =  &readf("$tpl_local_dir/playlist_del.tpl");
	for(@info)
	{
		s/<<file>>/$file/ig;
		s/<<ico_config>>/$ico_config/ig;
		s/<<cgi>>/$cgi_dir/ig;
	}
	unlink("$file") or die "couldnt delete $file\n";
	&update_mp3_pls;	
}

elsif($action eq "drive")
{
	chdir $file;
	$wd = cwd();
	@info = &lsdir;
}

elsif($action eq "file" and -d $file)
{
	chdir $file;
	$wd = cwd();
	@info = &lsdir;
}

elsif($action eq "file" && -f $file && $file =~ /\.(txt|bat|ini|nfo)$/i)
{
	@file = &readf("$file");
	@info = &readf("$tpl_local_dir/txt_display.tpl");
	for(@info)
	{
		s/<<file>>/@file/ig;
	}
	
}

elsif($action eq "links")
{
	@info = &readf("$links");
	for(@info)
	{
		$_ =~ s/^\s*-\s*/<hr style=\"width:80%;\"\/>/;
		$_ =~ s/^b$/<br\/>/i;
		$_ =~ s/(.*)\t+(.*)/<font size=\"5\"><a href=\"$2\">$1<\/a><\/font><br\/>\n/;
	}
}

elsif($action eq "file" && -f $file && $file =~ /\.(jpg|gif|png|jpeg)$/i)
{
	$cmd = " \"$perl_exe\" \"$cgi_local_dir/copyjpg.pl\" \"$our_wd\/$file\"";
	system("$cmd") or die "couldnt exec $cmd";
	
	@info = &readf("$tpl_local_dir/pic_display.tpl");
	for(@info)
	{
		s/<<images_dir>>/$images_dir/ig;
		s/<<file>>/$file/ig;
	}
	
}

elsif($action eq "file" && -f $file && $file =~ /\.mp3$/i)
{
	$cmd = " \"$perl_exe\" \"$cgi_local_dir/copymp3.pl\" \"$our_wd\/$file\"";
	system ("$cmd") or die "could exec $cmd";

	@info = &readf("$tpl_local_dir/mp3.tpl");
	for(@info)
	{
		s/<<theme_dir>>/$theme_dir/ig;
		s/<<ico_play>>/$ico_play/ig;
	}

	&update_mp3_pls;	
}

elsif($action eq "file" and -f $file && $file =~ /\.($mf_ext)$/i)
{
	$cmd = "\"$perl_exe\" \"$cgi_local_dir/encode.pl\" \"$our_wd\/$file\"";
	$rand = rand();
	open(FILE, ">>$work_dir/$rand.bat");
	print FILE "$cmd\n";
	close(FILE);

	@info = &readf("$tpl_local_dir/encoding.tpl");
	for(@info)
	{
		s/<<ico_play>>/$ico_play/ig;
		s/<<theme_dir>>/$theme_dir/ig;
	}
}

elsif($action eq "file" and !-f $file)
{
	$cwd = cwd();
	$error_msg = "sorry we cant see $file in current directory: $cwd";
	@info = &readf("$tpl_local_dir/error.tpl");
	for(@info)
	{
		s/<<error_msg>>/$error_msg/ig;
	}
}

#--------------------------------------------------------------------------------------------------------------
# Done everything, file in template and print webpage

for (@html)
{
	s/<<drives>>/@drives_data/ig;
	s/<<info>>/@info/ig;
	s/<<date>>/$date/ig;
	s/<<theme_dir>>/$theme_dir/ig;
	s/<<vars>>/$vars_data/ig;
	s/<<background>>/$background/ig;
	s/<<version>>/$version/ig;
	$_ =~ s/<<cgi>>/$cgi_dir/ig;
	s/<<wiicr_dir>>/$wiicr_dir/ig;
}

print @html;
exit 1;

#--------------------------------------------------------------------------------------------------------------
# subroutines
#--------------------------------------------------------------------------------------------------------------

sub readdir 
{
	my $d = shift;
	my @dl_1 = ();
	my @dl_2 = ();
	my @dl_3 = ();
	my @dl_4 = ();


	opendir(DIR, "$d") or nf_error("sub readdir cant open directory $d, $!");
	@dl_1 = readdir(DIR);
       	closedir DIR;

	for(@dl_1) 
	{
		if($_ eq ".") 
		{
			next;
		}
		push @dl_2, $_;
	}

	for(@dl_2)
	{
		if(-d $_)
		{
			push @dl_3, $_;
		}
		else
		{
			push @dl_4, $_;
		}
	}
	
	@dl_3 = sort(@dl_3);
	@dl_4 = sort(@dl_4);
	
	push @dl_3, @dl_4;

        return @dl_3;
}

#--------------------------------------------------------------------------------------------------------------

sub lsdir 
{
	my @dir = &readdir(".");
	my @data = ();
	my @tmp = ();
	my @tmp2 = ();
	
	@tmp = &readf("$tpl_local_dir/dir_header.tpl");
	for(@tmp)
	{
		s/<<cwd>>/$wd/ig;
	}
	
	push @data, @tmp;
	
	for(@dir)
	{
		if(!$_)
		{
			next;
		}
		$ico_tmp = $ico_bin;
		
		if(-d $_ && $_ eq "..")
		{
			$ico_tmp = $ico_up;
		}		
		elsif(-d $_)
		{
			$ico_tmp = $ico_dir;
		}		
		elsif(/\.(txt|ini|nfo)$/i)
		{
			$ico_tmp = $ico_txt;
		}		
		elsif(/\.mp3$/i)
		{
			$ico_tmp = $ico_mp3;
		}		
		elsif(/\.(jpg|jpeg|gif|png|bmp)$/i)
		{
			$ico_tmp = $ico_pic;
		}		
		elsif(/\.($mf_ext)$/i)
		{
			$ico_tmp = $ico_vid;
		}
		elsif(/\.(zip|ace|tar|gz|rar|r\d{2})$/i)
		{
			$ico_tmp = $ico_zip;
		}		
		
		$file = $_;
		@tmp = &readf("$tpl_local_dir/dir_body.tpl");
		for(@tmp)
		{
			s/<<file>>/$file/ig;
			s/<<icon>>/$ico_tmp/ig;
			s/<<cwd>>/$wd/ig;
			
		}
		
		push @data, @tmp;
	}
	push @data, &readf("$tpl_local_dir/dir_footer.tpl");
	
	return @data;
}

#--------------------------------------------------------------------------------------------------------------
sub lsmp3dir
{
	my @dir = &readdir(".");
	print "<!-- @dir -->\n";
	my @data = ();
	my @tmp = &readf("$tpl_local_dir/playlist_body.tpl");
	
	push @data, "<table bgcolor=\"black\" border=\"1\"><!-- lsmp3dir -->\n";
	
	for(@dir)
	{
		if(!$_)
		{
			next;
		}
		$ico_tmp = $ico_bin;
		
		if($_ !~ /\.mp3$/i)
		{
			next;
		}		

		$file = $_;
		@tmp2 = @tmp;
		for(@tmp2)
		{
			s/<<cwd>>/$wd/ig;
			s/<<file>>/$file/ig;
			s/<<ico_del>>/$ico_del/ig;
		}
		push @data, @tmp2;
	}
	return @data;
}


#--------------------------------------------------------------------------------------------------------------

sub readf {
        my $file = $_[0];

        open(FILE, "$file") or die("ERROR: Couldnt open $file to read.\n");
        my @file = <FILE>;
        close(FILE);

        return @file;
        
        return 1;
}

#--------------------------------------------------------------------------------------------------------------
# update_mp3_pls

# Note: its only xml code in this sub, 0 html.

sub update_mp3_pls 
{
	@tmp = &readdir("$mp3_local_dir");
	
	$tmp2 = "";
	open(FILE, ">$mp3_pls");
	print FILE
	"<playlist version=\"1\" xmlns=\"http://xspf.org/ns/0/\">\n\t<trackList>\n\n";
	for(@tmp)
	{
		if($_ !~ /\.mp3$/i)
		{
			next;
		}
		print FILE 
		"\t<track>\n\t\t<title>$_</title>\n\t\t<creator></creator>\n\t\t<location>$mp3_dir/$_</location>\n\t</track>\n\n";
	}
	
	print FILE 
	"\t</trackList>\n</playlist>\n";
	close(FILE);

	return 1;
}

1;